#include <bits/stdc++.h>

using namespace std;

int Ista(string &s,int i,int j, int k)
{
    int r=0;
    for(int x=0;x<=min(i-k-1,j-i);x++)
    {
        r+=int(s[i+x]==s[i-x-1]);
    }
    return r;
}

int main()
{
    string s;
    cin >>s;
    int n=s.size();
    vector <vector <int> > DP(n,vector <int>(n));
    for(int i=1;i<n;i++)
    {
        for(int j=i+1;j<n;j++)
        {
            for(int k=0;k<i-1;k++)
            {
                DP[i][j]=max(DP[i][j],DP[k][i-1]+Ista(s,i,j,k));
            }
        }
    }
    int rez=0;
    for(int i=0;i<n;i++)
    {
        rez=max(rez,DP[i][n-1]);
    }
    cout <<rez<<endl;
}